import React, {Component} from 'react'
import css from './index.scss'
//import Modal from 'react-modal-plugin'
import DataUtil from '../../../../util/dateTime'
//import ViewFile from 'kara-module-file-view'
//import 'kara-module-file-view/lib/index.css'
import {Modal, FileView} from 'karaui'
import tost,{errorTost} from "kara-module-tost";
import 'kara-module-tost/lib/index.css'

class FileComponent extends Component{
  constructor(props) {
    super(props)
    this.state = {
      showModal: false,
      showForwardModal: false,
      messageId: '',
        height: 'auto'
    }
      this.container = React.createRef()
  }

    componentDidMount() {
        if (this.state.height === 'auto' && this.container.current) {
            this.setState({ height: this.container.current.offsetHeight})
        }
    }
  getIconType = (fileType)=> {
    let className = 'kuc-iconfont '
    if(fileType.toLowerCase() === 'rar' || fileType.toLowerCase() === 'zip') {
      className += 'kuc-zip s-zip'
    }
    else if(fileType === 'ppt'|| fileType === 'pptx') {
      className += 'kuc-ppt s-ppt'
    }
    else if(fileType === 'xls'|| fileType === 'xlsx'){
      className += 'kuc-excel s-excel'
    }
    else if(fileType === 'doc'|| fileType === 'docx'){
      className += 'kuc-word s-word'
    }
    else {
      className += 'kuc-other s-file'
    }
    return className
  }
  cancelFavorite = (id,type) => {
    this.props.httpAgent.post(`/webapi/message/favorite/${id}/no`).then(
      res => {
        if(res && res.resultCode && res.resultCode === '000000') {
          tost({type:'success',msg:'取消收藏成功',time:4}) 
          this.props.cancelImFavorite(id, type, this.props.fromPage)
        }
        else {
          tost({type:'error',msg:'取消收藏失败',time:4}) 
        }
      }
    )
  }
  downLoadFile = (id, channelId) => {
    let abort = window.$file.download(id, channelId)
  }
  showModal= ()=> {
    this.setState({showModal:true})
  }
  hideModal= ()=> {
    this.setState({showModal:false})
  }
  modalForwardShow = (id) => {
    this.setState({showForwardModal: true})
    this.setState({messageId: id})
  }
  modalForwardHide = () => {
    this.setState({showForwardModal: false})
  }
  render(){
    const {lang,karaui:{Forward}} = this.props
    let fileAttr = this.props.fileAttr
    return (<div ref={this.container} className={`s-b-secondary ${css.fileContainer}`} style={{height: fileAttr.canceled ? 0 : this.state.height}}>
              <ul className={css.fileItem}>
                <li>
                  <div>
                    <p><i className={this.getIconType(fileAttr.fileType)}></i></p>
                    <div onClick={this.showModal}>
                      <span>{fileAttr.name}</span>
                      <span>{(fileAttr.size/1024/1024).toFixed(2)}M</span>
                    </div>
                  </div>
                </li>
                <li className='s-hint'>
                  <span>{lang.source}&nbsp;{fileAttr.fromUserName}</span>
                  <span>{DataUtil.DateShow(fileAttr.ts)}</span>
                  <span className={css.hoverShow} onClick={()=>{this.modalForwardShow(fileAttr.messageId)}}><i className='kuc-iconfont kuc-forward'></i>&nbsp;{lang.forward}</span>
                  <span className={css.hoverShow} onClick={()=>{this.downLoadFile(fileAttr.fileId, fileAttr.channel)}}><i className='kuc-iconfont kuc-download'></i>{lang.down}</span>
                  <span className={css.hoverShow} onClick={()=>{this.cancelFavorite(fileAttr.id,fileAttr.favoriteType)}}><i className='kuc-iconfont kuc-favorite s-primary'></i>&nbsp;取消收藏</span>
                </li>
              </ul>
              <Modal show={this.state.showModal} parent={this.props.contentRef.current}>
                <FileView file={fileAttr} isCollect={true} channelId={fileAttr.channel} modalHidden={this.hideModal} downloadBlobFile={this.downLoadFile} />
              </Modal>
              <Modal show={this.state.showForwardModal} onMask={this.modalForwardHide}>
                <Forward httpAgent={this.props.httpAgent} modalHidden={this.modalForwardHide} messageId={this.state.messageId} />
              </Modal>
            </div>
            )
  }
}

export default FileComponent
