import React, {Component} from 'react'
import {inject, observer} from "mobx-react"
import css from './index.scss'
import UCInfo from '../UCInfo/index'
import {action} from "mobx";
import {Tost} from "karaui";

@inject('IntegralStore', 'ConfigStore')
@observer
class KaraIntegral extends Component {

  constructor(props) {
    super(props)
    this.state = {
      storeUrl: null, //信商城地址
    }
  }

  componentDidMount() {
    const {IntegralStore, ConfigStore} = this.props
    this.props.ConfigStore.config.httpAgent.get('/points/mine/get').then(
      res => {
        if (res && res.resultCode && res.resultCode === '000000') {
          IntegralStore.getIntegral(res)
          IntegralStore.getAIIntegral(res)
        }
        else {
          Tost({type: 'error', msg: '获取积分失败', time: 4})
        }
      }
    )
    this.props.ConfigStore.config.httpAgent.get('/points/ssoLogin/callback').then(action(
      res => {
        // console.log("00000", res)
        if (res && res.resultCode && res.resultCode === '000000') {
          this.setState({storeUrl:res.ngLoginUrl})
        }
      }
    ))
  }

  render() {
    const {IntegralStore, lang} = this.props
    // console.log('积分',this.props)
    return (
      <div className={css.KaraIntegral}>
        <div>
          <div className='s-bg-page'>
            <div className='s-bg-score s-reverse'>
              <span>{lang.mallScore}</span>
              <span>{IntegralStore.pointer}<label>{lang.score}</label></span>
              <span>( 1{lang.yuan} = 100{lang.score} )</span>
            </div>
            <div className='s-bg-info'>
              {this.state.storeUrl ? <a className='btn btn-primary outline' href={this.state.storeUrl} target="_blank" >{lang.goShop}</a> : ''}
            </div>
          </div>

          <div className='s-bg-page'>
            <div className='s-bg-slider-dot s-reverse'>
              <span>{lang.lovelySystemScore}</span>
              <span>{IntegralStore.pointerAI}<label>{lang.score}</label></span>
              <span>( 1{lang.yuan} = 1{lang.score} )</span>
            </div>
            <div className='s-bg-ai-score'>
              <a className='btn btn-primary outline' href="https://officecloud.asiainfo.com/home/gojifensys"
                 target="_blank">
                {lang.goShop}
              </a>
            </div>
          </div>
        </div>
        <div className={css.noticeLabel}>
          <label>{lang.notice}</label>
          <label>{lang.notice1}</label>
          <label>{lang.notice2}</label>
          <label>{lang.notice3}</label>
        </div>
      </div>
    )
  }
}

export default KaraIntegral
